//BreakTextThread.jsx by Henryk Jursz, HenJ, http://www.jursz.com, may-july 2006, september 2007, january 2008
//An InDesign CS and CS2 JavaScript for breaking text thread

//all script messages
BTT_Script = "BreakTextThread 1.0, \u00a92006-2008 Henryk Jursz";

//is InDesign?
if ((app.name == "Adobe InDesign") && (app.documents.length != 0))
	{
	if (app.selection.length == 1)
		{
		//interaction off
		(app.version[0] < "4") ? (app.userInteractionLevel = UserInteractionLevels.neverInteract) : (app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract);
		if (app.selection[0].constructor.name != "TextFrame") exit();
		if (app.selection[0].textFrameIndex == 0) exit();
		//remember user selection
		var myBTT_SelFrame = app.selection[0];
		//select text from selected textframe to end of thread
		var myBTT_Index = myBTT_SelFrame.textFrameIndex;
		var myBTT_SelStory = myBTT_SelFrame.parentStory;
		var myBTT_Texts = myBTT_SelStory.characters.itemByRange(myBTT_SelFrame.characters.firstItem().index, myBTT_SelStory.characters.lastItem().index);
		myBTT_Texts.select();
		//export selected text to tempfile and delete text
		var myBTT_TempFile = new File(Folder.temp + "/" + "BTT_ThreadText.txt");
		var myBTT_ExpChSet = app.taggedTextExportPreferences.characterSet;
		var myBTT_ExpTForm = app.taggedTextExportPreferences.tagForm;
		app.taggedTextExportPreferences.characterSet = TagTextExportCharacterSet.unicode;
		app.taggedTextExportPreferences.tagForm = TagTextForm.verbose;
		app.selection[0].exportFile(ExportFormat.taggedText, myBTT_TempFile, false);
		app.taggedTextExportPreferences.characterSet = myBTT_ExpChSet;
		app.taggedTextExportPreferences.tagForm = myBTT_ExpTForm;
		app.selection[0].remove();
		//unlink textframe
		myBTT_SelFrame.previousTextFrame.nextTextFrame = null;
		//insert exported selection and remove tempfile
		var myBTT_ImpTForm = app.taggedTextImportPreferences.removeTextFormatting;
		var myBTT_ImpStyle = app.taggedTextImportPreferences.styleConflict;
		app.taggedTextImportPreferences.removeTextFormatting = false;
		app.taggedTextImportPreferences.styleConflict = StyleConflict.tagFileDefinition;
		myBTT_SelFrame.place(myBTT_TempFile, false, {autoflowing:true, retainingFormatting:true});
		app.taggedTextImportPreferences.removeTextFormatting = myBTT_ImpTForm;
		app.taggedTextImportPreferences.styleConflict = myBTT_ImpStyle;
		myBTT_TempFile.remove();
		app.selection = myBTT_SelFrame;
		//interaction on
		(app.version[0] < "4") ? (app.userInteractionLevel = UserInteractionLevels.interactWithAll) : (app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll);
		}
	}
//end of BreakTextThread script (by Henryk Jursz, HenJ 2006-2008)